﻿namespace U2UConsult.Win8.SemanticZoomWithLinq.DataAccess
{
    using System.Collections.Generic;
    using System.Linq;
    using U2UConsult.Win8.SemanticZoomWithLinq.Models;

    public partial class DAL
    {
        private static List<Item> items;
        private static IEnumerable<object> itemsByCategory;

        public static List<Item> Items
        {
            get
            {
                if (items == null)
                {
                    var result = new List<Item>();

                    result.Add(new Item() { Name = "Belle", ImagePath = "belle.jpg", CategoryName = "animals" });
                    result.Add(new Item() { Name = "Charlie", ImagePath = "charlie.png", CategoryName = "boys" });
                    result.Add(new Item() { Name = "Eudora", ImagePath = "eudora.png", CategoryName = "girls" });
                    result.Add(new Item() { Name = "Franklin", ImagePath = "franklin.png", CategoryName = "boys" });
                    result.Add(new Item() { Name = "Linus", ImagePath = "linus.png", CategoryName = "boys" });
                    result.Add(new Item() { Name = "Lucy", ImagePath = "lucy.png", CategoryName = "girls" });
                    result.Add(new Item() { Name = "Marcie", ImagePath = "marcie.png", CategoryName = "girls" });
                    result.Add(new Item() { Name = "Patty", ImagePath = "patty.png", CategoryName = "girls" });
                    result.Add(new Item() { Name = "Pig-pen", ImagePath = "pig-pen.png", CategoryName = "boys" });
                    result.Add(new Item() { Name = "Sally", ImagePath = "sally.png", CategoryName = "girls" });
                    result.Add(new Item() { Name = "Schroeder", ImagePath = "schroeder.jpg", CategoryName = "boys" });
                    result.Add(new Item() { Name = "Snoopy", ImagePath = "snoopy.gif", CategoryName = "animals" });
                    result.Add(new Item() { Name = "Spike", ImagePath = "spike.png", CategoryName = "animals" });
                    result.Add(new Item() { Name = "Woodstock", ImagePath = "woodstock.png", CategoryName = "animals" });

                    items = result;
                }

                return items;
            }
        }

        public static IEnumerable<object> ItemsByCategory
        {
            get
            {
                if (itemsByCategory == null)
                {
                    //itemsByCategory = from item in Items
                    //                  orderby item.CategoryName
                    //                  orderby item.Name
                    //                  group item by item.CategoryName into g
                    //                  orderby g.Key
                    //                  select g;

                    itemsByCategory = from item in Items
                                      orderby item.Name
                                      group item by item.Category into g
                                      orderby g.Key.Name
                                      select g;
                }

                return itemsByCategory;
            }
        }
    }
}
